deploy1 vor 7 Jahren
Commit
31593395fd
16 geänderte Dateien mit 783 neuen und 0 gelöschten Zeilen
  1. 7 0
      .dockerignore
  2. 1 0
      .gitignore
  3. 138 0
      CHANGELOG
  4. 28 0
      CloudronManifest.json
  5. 29 0
      DESCRIPTION.md
  6. 17 0
      Dockerfile
  7. 9 0
      LICENSE
  8. 202 0
      LICENSE.txt
  9. 8 0
      POSTINSTALL.md
  10. 1 0
      README.md
  11. 75 0
      config.json
  12. BIN
      logo.png
  13. 13 0
      start.sh
  14. 7 0
      test/.jshintrc
  15. 22 0
      test/package.json
  16. 226 0
      test/test.js

+ 7 - 0
.dockerignore

@@ -0,0 +1,7 @@
+.git
+.gitignore
+.dockerignore
+node_modules
+screenshots
+test
+

+ 1 - 0
.gitignore

@@ -0,0 +1 @@
+test/node_modules/

+ 138 - 0
CHANGELOG

@@ -0,0 +1,138 @@
+[0.1.0]
+* Initial version
+
+[0.1.1]
+* Added screenshots
+
+[0.2.0]
+* Updated to 2017-01-25T03-14-52Z
+
+[0.2.1]
+* Updated to 2017-02-16T01-47-30Z
+* This version fixes the settings bug
+
+[0.2.2]
+* New base image 0.10.0
+
+[0.2.3]
+* Updated to 2017-03-16T21-50-32Z
+
+[0.2.4]
+* Updated to 2017-04-25T01-27-49Z
+
+[0.2.5]
+* Updated to 2017-04-29T00-40-27Z
+
+[0.2.6]
+* Updated to 2017-05-05T01-14-51Z
+
+[0.2.7]
+* Updated to 2017-06-13T19-01-01Z
+
+[0.3.0]
+* Update to 2017-07-24T18-27-35Z
+
+[1.0.0]
+* Update to 2017-08-05T00-00-53Z
+
+[1.1.0]
+* Update to 2017-09-29T19-16-56Z
+* This version requires at Cloudron v1.7.2
+
+[1.2.0]
+* Update to 2017-10-27T18-59-02Z
+
+[1.3.0]
+* Update to 2017-11-22T19-55-46Z
+
+[1.4.0]
+* Update to 2017-12-28T01-21-00Z
+
+[1.5.0]
+* Update minio to 2018-01-02T23-07-00Z
+* Important [security fix](https://blog.minio.io/minio-release-jan-2nd-2018-security-advisory-ef0342a4ddba)
+* fix timing oracle attack against signature V2/V4 verification (#5335) (17 hours ago)
+* Fix PostPolicy form tests without hardcoded dates (#5337) (2 days ago)
+* Integrate existing remove bucket functionality from newux to current UI (#5289) (4 days ago)
+* Update config.json guide with details of version 22 (#5328) (5 days ago)
+* fix: Better printing of XL config init error (#5284) (5 days ago)
+* Fix config.json parsing to fetch correct storage class (#5327) (6 days ago)
+* Update yaml files to lastest version RELEASE.2017-12-28T01-21-00Z (6 days ago)
+
+[1.6.0]
+* Update minio to 2018-01-18T20-33-21Z
+* Critical [security fix](https://blog.minio.io/minio-release-jan-18-2018-security-advisory-4c64ca87721b)
+* Fix free and total space reported in startup banner (#5419) (25 hours ago)
+* replace all "crypto/sha256" with "github.com/minio/sha256-simd" (#5391) (26 hours ago)
+* gateway/manta: Bump manta dependencies (#5414) (26 hours ago)
+* fix authentication bypass against Admin-API (#5412) (26 hours ago)
+* Removes logrus package and refactors logging messages (#5293) (29 hours ago)
+* Document pre-existing data in fs mode (#5365) (30 hours ago)
+* Update storage class related documents (#5399) (35 hours ago)
+* Don't delete lock ops entry during state change (#5388) (2 days ago)
+* Remove upload healing related dead code (#5404) (3 days ago)
+* Fix multi-file dropzone upload issue causing bucket listing duplication (#5392) (5 days ago)
+
+[1.7.0]
+* Update minio to 2018-02-09T22-40-05Z
+* Rolling Upgrade Support to Minio Server.
+* Breaking Changes:
+    * Users using Minio Client mc with Minio Server will have to upgrade to the latest mc release
+    * Admin API has changed
+* Deprecated and removed in-memory object caching.
+* Default bit-rot protection is now using HighwayHash
+* Move to go1.9.4 with recent security release (#5502)
+* Seek to offset 0 after Truncate() (#5375)
+* Bring semantic versioning to provide for rolling upgrades (#5495)
+* Document object name limitations on Windows (#5491)
+* Deprecate and remove in-memory object caching (#5481)
+* Make sure to convert the disk errors to object errors (#5480)
+* Reduce Minio access key minimum length to 3 (#5478) <A. Elleuch>
+* Quorum based listing for XL (#5475)
+* fs.json file should be closed in CompleteMultipartUpload (#5482)
+* simplify storage class validation (#5470)
+* Remove stale code from minio server (#5479) 
+
+[1.8.0]
+* Update minio to 2018-03-12T21-25-28Z
+* Added comprehensive support for Server Side Encryption (SSE-C).
+* Fix deadlock in in-place CopyObject decryption/encryption (#5637)
+* Remove madmin docs from top level docs directory (#5636)
+* Add healthcheck endpoints (#5543)
+* Return authHeaderMalformed for an incorrect region in signature (#5618)
+* Save ETag when updating metadata (#5626)
+* Cleanup orchestration documents (#5623)
+* Remove unwanted errorIf calls (#5621)
+* SSE-C: Add support in Bucket Post Policy (#5607)
+* Support SSE-C multipart source objects in CopyObject (#5603)
+* Handle incoming proxy requests ip, scheme (#5591)
+* Make sure to filter out internal metadata (#5601)
+* Use toAPIErrorCode in HeadObject handler when decrypting request fails (#5600) 
+
+[1.9.0]
+* Update minio to 2018-03-16T22-52-12Z
+* Fixes a regression in Heal() implementation due to lock contention.
+* Major cleanup of notification sub-system.
+
+[1.9.0-1]
+* Update minio to 2018-03-19T19-22-06Z
+* This release fixes a critical migration issue when upgrading minio between certain versions. Please see issue for more details as described by community member (@kybi) here : #5667.
+* [refactor] simplify en/decrypted size computation (#5658)
+* Fix format migration regression (#5668)
+
+[1.10.0]
+* Update minio to 2018-03-30T00-38-44Z
+* Fix backend format for disk-cache - not to use FS format.json (#5732) (03/29/18)
+* Fix help message to be uniform across env vars (#5735) (03/30/18)
+* Apply storageClass data while config migration (#5737) (03/30/18)
+* Fix PUT bucket notification deadlocks (#5734) (03/29/18)
+* Fix block id length upto 8bytes only for azure gateway. (#5731) (03/29/18)
+* Improve some wording in disk caching docs (#5730) (03/28/18)
+* Remove deadcode related to multipart cleanup for fs (#5716) (03/28/18)
+
+[1.11.0]
+* Update minio to 2018-04-04T05-20-54Z
+
+[1.12.0]
+* Update minio to 2018-04-12T23-41-09Z
+

+ 28 - 0
CloudronManifest.json

@@ -0,0 +1,28 @@
+{
+  "id": "io.minio.cloudronapp",
+  "title": "Minio",
+  "author": "Minio Developers",
+  "description": "file://DESCRIPTION.md",
+  "changelog": "file://CHANGELOG",
+  "tagline": "Distributed object storage",
+  "version": "1.12.0",
+  "healthCheckPath": "/minio/login",
+  "httpPort": 8000,
+  "addons": {
+    "localstorage": {}
+  },
+  "manifestVersion": 1,
+  "website": "http://www.minio.io",
+  "minBoxVersion": "1.8.1",
+  "documentationUrl": "https://cloudron.io/documentation/apps/minio/",
+  "contactEmail": "support@cloudron.io",
+  "icon": "logo.png",
+  "tags": [
+    "storage",
+    "hosting"
+  ],
+  "mediaLinks": [
+    "https://raw.githubusercontent.com/minio/minio/master/docs/screenshots/minio-browser.jpg"
+  ],
+  "postInstallMessage": "file://POSTINSTALL.md"
+}

+ 29 - 0
DESCRIPTION.md

@@ -0,0 +1,29 @@
+This app packages Minio <upstream>2018-04-12T23-41-09Z</upstream>.
+
+Minio is a distributed object storage server built for cloud applications and devops.
+
+### Features
+
+#### Amazon S3 Compatible
+
+Minio implements Amazon S3 v4 APIs. Minio also includes client SDKs and a console utility.
+
+#### Minimalist Design
+
+Minio is deeply influenced by minimalism. We believe that only simple things scale.
+
+#### Apache License 2.0
+
+Minio is free software, released under Apache license v2.0. Minio has an active developer and user community.
+
+#### Lambda Functions
+
+Minio triggers Lambda functions through event notification service. In addition Minio also supports simple queueing service for AMQP, Elasticsearch, Redis, NATS and Postgres targets.
+
+#### Erasure Code & Bitrot Protection
+
+Minio protects data against hardware failures and silent data corruption using erasure code and checksums. You may lose half the number of drives and still recover from it.
+
+#### Written in Go
+
+Go is an emerging language of choice for modern cloud infrastructure projects. Go language enables Minio to be highly concurrent and lightweight.

+ 17 - 0
Dockerfile

@@ -0,0 +1,17 @@
+FROM cloudron/base:0.10.0
+
+EXPOSE 8000
+
+#ENV VERSION 2018-04-12T23-41-09Z
+ENV VERSION 2018-04-19T22-54-58Z
+
+RUN mkdir -p /app/code \
+    && wget https://dl.minio.io/server/minio/release/linux-amd64/archive/minio.RELEASE.${VERSION} -O /app/code/minio \
+    && chmod +x /app/code/minio
+
+WORKDIR /app/code
+
+ADD config.json /app/code/config.json
+ADD start.sh /app/code/start.sh
+
+CMD [ "/app/code/start.sh" ]

+ 9 - 0
LICENSE

@@ -0,0 +1,9 @@
+MIT License (MIT)
+Copyright (c) 2016 Cloudron UG
+
+Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+

+ 202 - 0
LICENSE.txt

@@ -0,0 +1,202 @@
+
+                                 Apache License
+                           Version 2.0, January 2004
+                        http://www.apache.org/licenses/
+
+   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
+
+   1. Definitions.
+
+      "License" shall mean the terms and conditions for use, reproduction,
+      and distribution as defined by Sections 1 through 9 of this document.
+
+      "Licensor" shall mean the copyright owner or entity authorized by
+      the copyright owner that is granting the License.
+
+      "Legal Entity" shall mean the union of the acting entity and all
+      other entities that control, are controlled by, or are under common
+      control with that entity. For the purposes of this definition,
+      "control" means (i) the power, direct or indirect, to cause the
+      direction or management of such entity, whether by contract or
+      otherwise, or (ii) ownership of fifty percent (50%) or more of the
+      outstanding shares, or (iii) beneficial ownership of such entity.
+
+      "You" (or "Your") shall mean an individual or Legal Entity
+      exercising permissions granted by this License.
+
+      "Source" form shall mean the preferred form for making modifications,
+      including but not limited to software source code, documentation
+      source, and configuration files.
+
+      "Object" form shall mean any form resulting from mechanical
+      transformation or translation of a Source form, including but
+      not limited to compiled object code, generated documentation,
+      and conversions to other media types.
+
+      "Work" shall mean the work of authorship, whether in Source or
+      Object form, made available under the License, as indicated by a
+      copyright notice that is included in or attached to the work
+      (an example is provided in the Appendix below).
+
+      "Derivative Works" shall mean any work, whether in Source or Object
+      form, that is based on (or derived from) the Work and for which the
+      editorial revisions, annotations, elaborations, or other modifications
+      represent, as a whole, an original work of authorship. For the purposes
+      of this License, Derivative Works shall not include works that remain
+      separable from, or merely link (or bind by name) to the interfaces of,
+      the Work and Derivative Works thereof.
+
+      "Contribution" shall mean any work of authorship, including
+      the original version of the Work and any modifications or additions
+      to that Work or Derivative Works thereof, that is intentionally
+      submitted to Licensor for inclusion in the Work by the copyright owner
+      or by an individual or Legal Entity authorized to submit on behalf of
+      the copyright owner. For the purposes of this definition, "submitted"
+      means any form of electronic, verbal, or written communication sent
+      to the Licensor or its representatives, including but not limited to
+      communication on electronic mailing lists, source code control systems,
+      and issue tracking systems that are managed by, or on behalf of, the
+      Licensor for the purpose of discussing and improving the Work, but
+      excluding communication that is conspicuously marked or otherwise
+      designated in writing by the copyright owner as "Not a Contribution."
+
+      "Contributor" shall mean Licensor and any individual or Legal Entity
+      on behalf of whom a Contribution has been received by Licensor and
+      subsequently incorporated within the Work.
+
+   2. Grant of Copyright License. Subject to the terms and conditions of
+      this License, each Contributor hereby grants to You a perpetual,
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
+      copyright license to reproduce, prepare Derivative Works of,
+      publicly display, publicly perform, sublicense, and distribute the
+      Work and such Derivative Works in Source or Object form.
+
+   3. Grant of Patent License. Subject to the terms and conditions of
+      this License, each Contributor hereby grants to You a perpetual,
+      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
+      (except as stated in this section) patent license to make, have made,
+      use, offer to sell, sell, import, and otherwise transfer the Work,
+      where such license applies only to those patent claims licensable
+      by such Contributor that are necessarily infringed by their
+      Contribution(s) alone or by combination of their Contribution(s)
+      with the Work to which such Contribution(s) was submitted. If You
+      institute patent litigation against any entity (including a
+      cross-claim or counterclaim in a lawsuit) alleging that the Work
+      or a Contribution incorporated within the Work constitutes direct
+      or contributory patent infringement, then any patent licenses
+      granted to You under this License for that Work shall terminate
+      as of the date such litigation is filed.
+
+   4. Redistribution. You may reproduce and distribute copies of the
+      Work or Derivative Works thereof in any medium, with or without
+      modifications, and in Source or Object form, provided that You
+      meet the following conditions:
+
+      (a) You must give any other recipients of the Work or
+          Derivative Works a copy of this License; and
+
+      (b) You must cause any modified files to carry prominent notices
+          stating that You changed the files; and
+
+      (c) You must retain, in the Source form of any Derivative Works
+          that You distribute, all copyright, patent, trademark, and
+          attribution notices from the Source form of the Work,
+          excluding those notices that do not pertain to any part of
+          the Derivative Works; and
+
+      (d) If the Work includes a "NOTICE" text file as part of its
+          distribution, then any Derivative Works that You distribute must
+          include a readable copy of the attribution notices contained
+          within such NOTICE file, excluding those notices that do not
+          pertain to any part of the Derivative Works, in at least one
+          of the following places: within a NOTICE text file distributed
+          as part of the Derivative Works; within the Source form or
+          documentation, if provided along with the Derivative Works; or,
+          within a display generated by the Derivative Works, if and
+          wherever such third-party notices normally appear. The contents
+          of the NOTICE file are for informational purposes only and
+          do not modify the License. You may add Your own attribution
+          notices within Derivative Works that You distribute, alongside
+          or as an addendum to the NOTICE text from the Work, provided
+          that such additional attribution notices cannot be construed
+          as modifying the License.
+
+      You may add Your own copyright statement to Your modifications and
+      may provide additional or different license terms and conditions
+      for use, reproduction, or distribution of Your modifications, or
+      for any such Derivative Works as a whole, provided Your use,
+      reproduction, and distribution of the Work otherwise complies with
+      the conditions stated in this License.
+
+   5. Submission of Contributions. Unless You explicitly state otherwise,
+      any Contribution intentionally submitted for inclusion in the Work
+      by You to the Licensor shall be under the terms and conditions of
+      this License, without any additional terms or conditions.
+      Notwithstanding the above, nothing herein shall supersede or modify
+      the terms of any separate license agreement you may have executed
+      with Licensor regarding such Contributions.
+
+   6. Trademarks. This License does not grant permission to use the trade
+      names, trademarks, service marks, or product names of the Licensor,
+      except as required for reasonable and customary use in describing the
+      origin of the Work and reproducing the content of the NOTICE file.
+
+   7. Disclaimer of Warranty. Unless required by applicable law or
+      agreed to in writing, Licensor provides the Work (and each
+      Contributor provides its Contributions) on an "AS IS" BASIS,
+      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
+      implied, including, without limitation, any warranties or conditions
+      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
+      PARTICULAR PURPOSE. You are solely responsible for determining the
+      appropriateness of using or redistributing the Work and assume any
+      risks associated with Your exercise of permissions under this License.
+
+   8. Limitation of Liability. In no event and under no legal theory,
+      whether in tort (including negligence), contract, or otherwise,
+      unless required by applicable law (such as deliberate and grossly
+      negligent acts) or agreed to in writing, shall any Contributor be
+      liable to You for damages, including any direct, indirect, special,
+      incidental, or consequential damages of any character arising as a
+      result of this License or out of the use or inability to use the
+      Work (including but not limited to damages for loss of goodwill,
+      work stoppage, computer failure or malfunction, or any and all
+      other commercial damages or losses), even if such Contributor
+      has been advised of the possibility of such damages.
+
+   9. Accepting Warranty or Additional Liability. While redistributing
+      the Work or Derivative Works thereof, You may choose to offer,
+      and charge a fee for, acceptance of support, warranty, indemnity,
+      or other liability obligations and/or rights consistent with this
+      License. However, in accepting such obligations, You may act only
+      on Your own behalf and on Your sole responsibility, not on behalf
+      of any other Contributor, and only if You agree to indemnify,
+      defend, and hold each Contributor harmless for any liability
+      incurred by, or claims asserted against, such Contributor by reason
+      of your accepting any such warranty or additional liability.
+
+   END OF TERMS AND CONDITIONS
+
+   APPENDIX: How to apply the Apache License to your work.
+
+      To apply the Apache License to your work, attach the following
+      boilerplate notice, with the fields enclosed by brackets "[]"
+      replaced with your own identifying information. (Don't include
+      the brackets!)  The text should be enclosed in the appropriate
+      comment syntax for the file format. We also recommend that a
+      file or class name and description of purpose be included on the
+      same "printed page" as the copyright notice for easier
+      identification within third-party archives.
+
+   Copyright [yyyy] [name of copyright owner]
+
+   Licensed under the Apache License, Version 2.0 (the "License");
+   you may not use this file except in compliance with the License.
+   You may obtain a copy of the License at
+
+       http://www.apache.org/licenses/LICENSE-2.0
+
+   Unless required by applicable law or agreed to in writing, software
+   distributed under the License is distributed on an "AS IS" BASIS,
+   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+   See the License for the specific language governing permissions and
+   limitations under the License.

+ 8 - 0
POSTINSTALL.md

@@ -0,0 +1,8 @@
+This application does not integrate with Cloudron authentication.
+
+Please use the following credentials to login:
+
+* AccessKey: `admin`
+* SecretKey: `secretkey`
+
+**Please change the credentials immediately**

+ 1 - 0
README.md

@@ -0,0 +1 @@
+##minio-app-alt

+ 75 - 0
config.json

@@ -0,0 +1,75 @@
+{
+        "version": "10",
+        "credential": {
+                "accessKey": "admin",
+                "secretKey": "secretkey"
+        },
+        "region": "us-east-1",
+        "logger": {
+                "console": {
+                        "enable": true,
+                        "level": "error"
+                },
+                "file": {
+                        "enable": false,
+                        "fileName": "",
+                        "level": ""
+                }
+        },
+        "notify": {
+                "amqp": {
+                        "1": {
+                                "enable": false,
+                                "url": "",
+                                "exchange": "",
+                                "routingKey": "",
+                                "exchangeType": "",
+                                "mandatory": false,
+                                "immediate": false,
+                                "durable": false,
+                                "internal": false,
+                                "noWait": false,
+                                "autoDeleted": false
+                        }
+                },
+                "nats": {
+                        "1": {
+                                "enable": false,
+                                "address": "",
+                                "subject": "",
+                                "username": "",
+                                "password": "",
+                                "token": "",
+                                "secure": false,
+                                "pingInterval": 0
+                        }
+                },
+                "elasticsearch": {
+                        "1": {
+                                "enable": false,
+                                "url": "",
+                                "index": ""
+                        }
+                },
+                "redis": {
+                        "1": {
+                                "enable": false,
+                                "address": "",
+                                "password": "",
+                                "key": ""
+                        }
+                },
+                "postgresql": {
+                        "1": {
+                                "enable": false,
+                                "connectionString": "",
+                                "table": "",
+                                "host": "",
+                                "port": "",
+                                "user": "",
+                                "password": "",
+                                "database": ""
+                        }
+                }
+        }
+}

BIN
logo.png


+ 13 - 0
start.sh

@@ -0,0 +1,13 @@
+#!/bin/bash
+
+set -eu
+
+mkdir -p /app/data/data /app/data/config
+
+if ! [ -f /app/data/config/config.json ]; then
+  cp /app/code/config.json /app/data/config/config.json
+fi
+
+exec ./minio server -C /app/data/config --address :8000 /app/data/data
+
+

+ 7 - 0
test/.jshintrc

@@ -0,0 +1,7 @@
+{
+	"node": true,
+	"browser": true,
+	"unused": true,
+	"globalstrict": true,
+	"predef": [ "angular", "$", "describe", "it", "before", "after" ]
+}

+ 22 - 0
test/package.json

@@ -0,0 +1,22 @@
+{
+  "name": "test",
+  "version": "1.0.0",
+  "description": "",
+  "main": "index.js",
+  "scripts": {
+    "test": "echo \"Error: no test specified\" && exit 1"
+  },
+  "author": "",
+  "license": "ISC",
+  "dependencies": {
+    "chromedriver": "^2.36.0",
+    "ejs": "^2.4.2",
+    "expect.js": "^0.3.1",
+    "mkdirp": "^0.5.1",
+    "mocha": "^2.5.3",
+    "rimraf": "^2.5.3",
+    "selenium-server-standalone-jar": "^2.53.1",
+    "selenium-webdriver": "^2.53.3",
+    "superagent": "^1.4.0"
+  }
+}

+ 226 - 0
test/test.js

@@ -0,0 +1,226 @@
+#!/usr/bin/env node
+
+'use strict';
+
+require('chromedriver');
+
+var execSync = require('child_process').execSync,
+    expect = require('expect.js'),
+    path = require('path'),
+    webdriver = require('selenium-webdriver');
+
+var by = webdriver.By,
+    until = webdriver.until;
+
+var accessKey = 'admin',
+    secretKey = 'secretkey';
+
+var bucket = 'cloudrontestbucket';
+
+process.env.NODE_TLS_REJECT_UNAUTHORIZED = '0';
+
+
+describe('Application life cycle test', function () {
+    this.timeout(0);
+
+    var chrome = require('selenium-webdriver/chrome');
+    var server, browser = new chrome.Driver();
+
+    before(function (done) {
+        var seleniumJar= require('selenium-server-standalone-jar');
+        var SeleniumServer = require('selenium-webdriver/remote').SeleniumServer;
+        server = new SeleniumServer(seleniumJar.path, { port: 4444 });
+        server.start();
+
+        done();
+    });
+
+    after(function (done) {
+        browser.quit();
+        server.stop();
+        done();
+    });
+
+    var LOCATION = 'test';
+    var TEST_TIMEOUT = 10000;
+    var app;
+
+    function pageLoaded() {
+        return browser.wait(until.elementLocated(by.className('page-load pl-0 pl-1')), TEST_TIMEOUT);
+    }
+
+    function visible(selector) {
+        return browser.wait(until.elementLocated(selector), TEST_TIMEOUT).then(function () {
+            return browser.wait(until.elementIsVisible(browser.findElement(selector)), TEST_TIMEOUT);
+        });
+    }
+
+    function login(callback) {
+        browser.manage().deleteAllCookies();
+        browser.get('https://' + app.fqdn).then(function () {
+            return visible(by.id('accessKey'));
+        }).then(function () {
+            return browser.findElement(by.id('accessKey')).sendKeys(accessKey);
+        }).then(function () {
+            return browser.findElement(by.id('secretKey')).sendKeys(secretKey);
+        }).then(function () {
+            // return browser.findElement(by.className('lw-btn')).click();
+            return browser.findElement(by.tagName('form')).submit();
+        }).then(function () {
+            return browser.wait(until.elementLocated(by.id('top-right-menu')), TEST_TIMEOUT);
+        }).then(function () {
+            callback();
+        });
+    }
+
+    function logout(callback) {
+        browser.get('https://' + app.fqdn);
+
+        pageLoaded().then(function () {
+            return visible(by.id('top-right-menu'));
+        }).then(function () {
+            return browser.findElement(by.id('top-right-menu')).click();
+        }).then(function () {
+            return visible(by.xpath('//*[text()="Sign Out "]'));
+        }).then(function () {
+            return browser.findElement(by.xpath('//*[text()="Sign Out "]')).click();
+        }).then(function () {
+            return browser.wait(until.elementLocated(by.id('accessKey')), TEST_TIMEOUT);
+        }).then(function () {
+            callback();
+        });
+    }
+
+    function addBucket(callback) {
+        browser.get('https://' + app.fqdn);
+
+        pageLoaded().then(function () {
+            return visible(by.className('fa fa-plus'));
+        }).then(function () {
+            return browser.findElement(by.className('fa fa-plus')).click();
+        }).then(function () {
+            return visible(by.className('fa fa-hdd-o'));
+        }).then(function () {
+            return browser.findElement(by.className('fa fa-hdd-o')).click();
+        }).then(function () {
+            return visible(by.xpath('//*[@class="modal-body"]/form/div/input'));
+        }).then(function () {
+            return browser.findElement(by.xpath('//*[@class="modal-body"]/form/div/input')).sendKeys(bucket);
+        }).then(function () {
+            return browser.findElement(by.xpath('//*[@class="modal-body"]/form')).submit();
+        }).then(function () {
+            return visible(by.xpath('//*[@class="main"]/a[text()="' + bucket + '"]'));
+        }).then(function () {
+            callback();
+        });
+    }
+
+    function checkBucket(callback) {
+        browser.get('https://' + app.fqdn);
+
+        pageLoaded().then(function () {
+            return browser.findElement(by.xpath(`//a[contains(text(), ${bucket})]`));
+        }).then(function () {
+            callback();
+        });
+    }
+
+    function openSettings(callback) {
+        browser.get('https://' + app.fqdn);
+
+        pageLoaded().then(function () {
+            return visible(by.id('top-right-menu'));
+        }).then(function () {
+            return browser.findElement(by.id('top-right-menu')).click();
+        }).then(function () {
+            return visible(by.xpath('//*[contains(text(), "Change Password")]'));
+        }).then(function () {
+            return browser.findElement(by.xpath('//*[contains(text(),"Change Password")]')).click();
+        }).then(function () {
+            return browser.wait(until.elementLocated(by.xpath('//*[contains(text(), "Change Password")]')), TEST_TIMEOUT);
+        }).then(function () {
+            callback();
+        });
+    }
+
+    xit('build app', function () {
+        execSync('cloudron build', { cwd: path.resolve(__dirname, '..'), stdio: 'inherit' });
+    });
+
+    it('install app', function () {
+        execSync('cloudron install --new --wait --location ' + LOCATION, { cwd: path.resolve(__dirname, '..'), stdio: 'inherit' });
+    });
+
+    it('can get app information', function () {
+        var inspect = JSON.parse(execSync('cloudron inspect'));
+
+        app = inspect.apps.filter(function (a) { return a.location === LOCATION; })[0];
+
+        expect(app).to.be.an('object');
+    });
+
+    it('can login', login);
+    it('can add bucket', addBucket);
+    it('can open settings', openSettings);
+    it('can logout', logout);
+
+    it('can restart app', function (done) {
+        execSync('cloudron restart --wait');
+        done();
+    });
+
+    it('can login', login);
+    it('has bucket', checkBucket);
+    it('can logout', logout);
+
+    it('backup app', function () {
+        execSync('cloudron backup create --app ' + app.id, { cwd: path.resolve(__dirname, '..'), stdio: 'inherit' });
+    });
+
+    it('restore app', function () {
+        execSync('cloudron restore --app ' + app.id, { cwd: path.resolve(__dirname, '..'), stdio: 'inherit' });
+    });
+
+    it('can login', login);
+    it('has bucket', checkBucket);
+    it('can open settings', openSettings);
+    it('can logout', logout);
+
+    it('move to different location', function () {
+        browser.manage().deleteAllCookies();
+        execSync('cloudron configure --wait --location ' + LOCATION + '2', { cwd: path.resolve(__dirname, '..'), stdio: 'inherit' });
+        var inspect = JSON.parse(execSync('cloudron inspect'));
+        app = inspect.apps.filter(function (a) { return a.location === LOCATION + '2'; })[0];
+        expect(app).to.be.an('object');
+    });
+
+    it('can login', login);
+    it('has bucket', checkBucket);
+    it('can logout', logout);
+
+    it('uninstall app', function () {
+        execSync('cloudron uninstall --app ' + app.id, { cwd: path.resolve(__dirname, '..'), stdio: 'inherit' });
+    });
+
+    // test update
+    it('can install app', function () {
+        execSync('cloudron install --new --wait --appstore-id io.minio.cloudronapp --location ' + LOCATION, { cwd: path.resolve(__dirname, '..'), stdio: 'inherit' });
+        var inspect = JSON.parse(execSync('cloudron inspect'));
+        app = inspect.apps.filter(function (a) { return a.location === LOCATION; })[0];
+        expect(app).to.be.an('object');
+    });
+
+    it('can login', login);
+    it('can add buckets', addBucket);
+    it('can logout', logout);
+    it('can update', function () {
+        execSync('cloudron install --wait --app ' + LOCATION, { cwd: path.resolve(__dirname, '..'), stdio: 'inherit' });
+    });
+    it('can login', login);
+    it('has bucket', checkBucket);
+    it('can logout', logout);
+    it('uninstall app', function () {
+        execSync('cloudron uninstall --app ' + app.id, { cwd: path.resolve(__dirname, '..'), stdio: 'inherit' });
+    });
+});
+